//NumberFlash.js
//Random number generator, French-text-converter, coordinator, magnifique!
//Luke McKenzie theclockspot.com 2008-04-02

var mode=true; //false = generate number; true = generate text ans.
var numberHolder=''; //holds number during false mode
var leVersion='0.1';

function load() { //runs on, as one might assume, widget load
    //setupParts();
	entered('');
}

function keyPress(event,ourform) {
	if(event && event.which == 13) entered(ourform.answer.value);
	else return true;
}

function entered(x) { //called when enter/return is struck on the textbox
	mode = !mode; //flip it like a piece of prospective real estate
	if(!mode) {
		numberHolder = generateNumber();
		updateDoc(numberHolder,'question');
			//update question field with the numerical value
	}
	else {
		//generate correct text
		z = generateText(numberHolder);
		//update answer field with correct text value
		updateDoc(z,'answer');
		//update background of widget if appropriate
		if(x) { //only do it if an answer was given
			if(x==z) document.getElementById("front").style.background =
				"url('bgright.png') left top no-repeat";
			else document.getElementById("front").style.background = 
				"url('bgwrong.png') left top no-repeat";
		}
	}
}

function updateDoc(y,x) {
	switch(x) {
		case 'question':
			document.getElementById("question").innerHTML = y;
			document.getElementById("answer").value = '';
			document.getElementById("front").style.background = 
				"url('bgnormal.png') left top no-repeat";
			break;
		case 'answer': document.getElementById("answer").value = y;
			break;
	}
}

function generateNumber() {
	//Generates the number in numerical form.
	//Choose a random number of maximum digits between 1 and 4
	numDigits = Math.floor(Math.random()*4)+1;
	//Make a number - for example, floor(rand*(10^2)) => floor(rand*100) => 0 <= x <= 99
	theRandomNumber = Math.floor(Math.random()*(Math.pow(10,numDigits)));
		//Why don't I simply do Math.floor(Math.random()*10000) since I want a max of four digits?
		//This method returns more numbers of smaller denominations.
		//But because it's a *maximum* number of digits (i.e. 1-9999 rather than 1000-9999)
		//there may yet be a problem.
	//If it's to be a decimal (probability 1/2), divide by 10.
	if(Math.floor(Math.random()*2)) theRandomNumber /= 10; //that random thing will be either 0 or 1
	return theRandomNumber;
}

//number words used inside separator groups
//used by generateTextSepGrp()
var textBits = [];
textBits[0] = 'zero';
textBits[1] = 'un';
textBits[2] = 'deux';
textBits[3] = 'trois';
textBits[4] = 'quatre';
textBits[5] = 'cinq';
textBits[6] = 'six';
textBits[7] = 'sept';
textBits[8] = 'huit';
textBits[9] = 'neuf';
textBits[10] = 'dix';
textBits[11] = 'onze';
textBits[12] = 'douze';
textBits[13] = 'treize';
textBits[14] = 'quatorze';
textBits[15] = 'quinze';
textBits[16] = 'seize';
textBits[17] = 'dix-sept';
textBits[18] = 'dix-huit';
textBits[19] = 'dix-neuf';
textBits[20] = 'vingt';
textBits[30] = 'trente';
textBits[40] = 'quarante';
textBits[50] = 'cinquante';
textBits[60] = 'soixante';
textBits[80] = 'quatre-vingt';

function spaceIt(x) {
	//Convention of text assembly:
	//if the string is empty, do nothing, as your element will be first in it;
	//otherwise, as it is not first, add a space BEFORE your element.
	if(x=='') return '';
	else return ' ';
}

//Thankfully, as in English, numbers are expressed in French in groups
//of three digits set off by separators. I call these "separator groups."
//generateText() processes the entire number, a sep grp at a time;
//it also handles zero values for individual sep grps (or the whole number).
//generateTextSepGrp() processes individual separator groups.

//Separator group words (to be applied by generateText()).
//                        French      English
//                10^18 = trillion  = quintillion = 7 sep grps
//                10^15 = billiard? = quadrillion = 6 sep grps
//                10^12 = billion  	= trillion    = 5 sep grps
//1 000 000 000 = 10^9  = million  	= billion     = 4 sep grps
//    1 000 000 = 10^6  = milliard 	= million     = 3 sep grps
//        1 000 = 10^3  = mille    	= thousand    = 2 sep grps
//Do group words larger than mille ever take an s?
//And how the CRAP are sep grps described after the decimal?

function generateText(theNumber) {
	//create playground text variable
	theText = '';
	//we'll only work with the first two sep grps (mille and base)
	//and the first sep grp after the decimal
	
	//mille sep grp
	if(theNumber>=1000) {
		//as this is the largest sepgrp we're testing for,
		//it won't be zero if this code is executing,
		//mille never takes an s
		x = generateTextSepGrp(Math.floor((theNumber%1000000)/1000));
		if(x) theText += spaceIt(theText) + x + ' mille';
	}
	//there is no connecting word between sep grps
	//base sep grp
	if(theNumber>=1) {
		//unlike mille sep grp, we must test for zero
		//and previous contents in theText
		x = generateTextSepGrp(Math.floor(theNumber%1000));
		if(x) theText += spaceIt(theText) + x;
	}
	//zero case (for the whole number, at least)
	if(theText=='') theText = textBits[0];
	//decimal sep grps, if applicable - ok, really just one digit (HACK)
	if((theNumber%1)>0) { //(that returns decimal component)
		theText += ' vergule '; //break my own spacing guideline
		x = generateTextSepGrp((theNumber*10)%10);
		if(x) theText += x; else theText += 'zero';
	}
	return theText;
}

function generateTextSepGrp(theNum) {
	//Used to return a number up to three places.
	//Reused by generateText() for each separator group.
	//(For example: if n=10.459.263,45 this runs four times.)
	theText2 = ''; //create playground text variable
	c = theNum%10; //units - mind that this can go up to 19
	b = (theNum%100)-c; //tens with trailing zeros
	a = theNum-b-c; //hundreds with trailing zeros
	//a+b+c = theNum
	//Hundreds----------------
	if(a>0) {
		//If >=200, an ordinal number precedes cent (e.g. deux cent quatre)
		if(a>=200) theText2+=textBits[a/100];
		theText2+=spaceIt(theText2)+'cent';
		//If exact hundred (%100=0), cent has an s (e.g. deux cents)
		if((b+c)==0) theText2+='s';
		//There is no connecting word ("et") between hundreds and tens
	}
	//Tens--------------------
	//For 0-19, 60-79, and 80-99, units is actually a range of 0-19.
	//In those cases, we move the second 10 (if applicable) from b to c.
	if(b==10 || b==70 || b==90) { b-=10; c+=10; }
	//If b<20, no tens word is needed; else add it.
	if(b>=20) theText2+=spaceIt(theText2)+textBits[b];
	//Units-------------------
		//Zero handling is performed by generateText(), not here.
	//If units=0, we don't add a units word (zeros handled by generateText())
	//but if b==80, add an s to tens word (quatre-vingts).
	if(c==0) { if(b==80) theText2+='s'; }
	else { //units > 0
		//if there's no tens-word (1-19), just do the ones-word
		if(b==0) theText2+=spaceIt(theText2)+textBits[c];
		else { //if there is a tens-word, we must do some kind of liaison
			if(c==1) theText2+=' et un';
			if(c>1) theText2+='-'+textBits[c];
		}
	}
	return theText2;
}

function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

/*if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}*/
